# TODO
# - system lua-lfs for tests (LuaFileSystem 1.2)
# - daemon does not close its std fds
# - with keepalive=yes (angel mode) killing child with TERM sometimes does
#   nothing and your restart has to send SIGKILL eventually, seems it's just
#   losing the signal (some race?).
#   clock_gettime(CLOCK_MONOTONIC, {8381139, 777478778}) = 0
#   epoll_wait(6, {}, 8191, 962)            = 0
#   clock_gettime(CLOCK_MONOTONIC, {8381140, 739212126}) = 0
#   epoll_wait(6, {}, 8191, 1000)           = 0
#   clock_gettime(CLOCK_MONOTONIC, {8381141, 742484533}) = 0
#   - child TERM seems broken in non-angel mode as well (just loses it).
#   - child HUP seems broken in non-angel mode as well (sees it only once).
# - tests need fixing (can't find libs it built)
# OLD TODO
# - rw splitting bug: http://bugs.mysql.com/bug.php?id=36505
#   http://jan.kneschke.de/2007/8/26/mysql-proxy-more-r-w-splitting
#   http://www.teonator.net/2008/11/25/drupal-read-write-splitting/
#   http://dailyvim.blogspot.com/2008/07/mysql-high-availability-sandbox-proxy.html
#   https://launchpad.net/mysql-sandbox
# - move LUA_PATH to %{_datadir} chassis_frontend_get_default_lua_path()
#
# Conditional build:
%bcond_with	tests		# build with tests. needs mysql server on localhost:3306

Summary:	MySQL Proxy
Summary(pl.UTF-8):	Proxy MySQL
Name:		mysql-proxy
Version:	0.8.4
Release:	1
License:	GPL v2
Group:		Applications/Networking
Source0:	ftp://mysql.mirror.kangaroot.net/pub/mysql/Downloads/MySQL-Proxy/%{name}-%{version}.tar.gz
# Source0-md5:	39f4743be3042db0254c2d62575264c8
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.conf
Source4:	admin-1.lua
Patch0:		install-examples.patch
URL:		http://forge.mysql.com/wiki/MySQL_Proxy
BuildRequires:	autoconf >= 2.62
BuildRequires:	automake
BuildRequires:	glib2-devel >= 1:2.4.0
BuildRequires:	libevent-devel
BuildRequires:	libtool
BuildRequires:	lua51-devel
BuildRequires:	mysql-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
%if %{with tests}
BuildRequires:	check
BuildRequires:	lua51
%endif
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts >= 0.4.2.8
Provides:	group(mysqlproxy)
Provides:	user(mysqlproxy)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_includedir	%{_prefix}/include/%{name}

%description
MySQL Proxy is a simple program that sits between your client and
MySQL server(s) that can monitor, analyze or transform their
communication. Its flexibility allows for unlimited uses; common ones
include: load balancing; failover; query analysis; query filtering and
modification; and many more.

%description -l pl.UTF-8
MySQL Proxy to prosty program tkwiący między klienten a
serwerem/serwerami MySQL, potrafiący monitorować, analizować i
przekształcać ich komunikację. Jego elastyczność pozwala na
nieograniczone wykorzystanie; popularne sposoby użycia obejmują: load
balancing, failover, analizę zapytań, filtrowanie i modyfikowanie
zapytań... i wiele więcej.

%prep
%setup -q
%patch0 -p1

%{__sed} -i -e 's/g_build_filename(base_dir, "lib"/g_build_filename(base_dir, "%{_lib}"/g' src/chassis-frontend.c
%{__sed} -i -e 's/g_build_filename(srv->base_dir, "lib"/g_build_filename(srv->base_dir, "%{_lib}"/g' src/chassis-frontend.c

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--with-lua=lua51
%{__make}

%if %{with tests}
export MYSQL_USER=mysql
export MYSQL_PASSWORD=
export MYSQL_HOST=localhost
export MYSQL_DB=test
%{__make} -C tests/suite check
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{/etc/{rc.d/init.d,sysconfig},%{_sysconfdir}/%{name},/var/log/{archive,}/%{name}}
install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/%{name}.conf

# daemon in sbindir
install -d $RPM_BUILD_ROOT%{_sbindir}
mv $RPM_BUILD_ROOT{%{_bindir},%{_sbindir}}/mysql-proxy

# noarch data to %{_datadir}
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}/lua
mv $RPM_BUILD_ROOT{%{_libdir},%{_datadir}}/%{name}/lua/proxy
mv $RPM_BUILD_ROOT{%{_libdir},%{_datadir}}/%{name}/lua/examples
mv $RPM_BUILD_ROOT{%{_libdir},%{_datadir}}/%{name}/lua/admin.lua
# contrib lua
cp -p %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/%{name}/lua/proxy

%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{name}/plugins/*.la
%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{name}/lua/*.la

# no -devel, kill
%{__rm} -r $RPM_BUILD_ROOT%{_includedir}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libmysql-*.la
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libmysql-*.so
%{__rm} -r $RPM_BUILD_ROOT%{_pkgconfigdir}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 193 mysqlproxy
%useradd -u 193 -g mysqlproxy -c "MySQL Proxy" mysqlproxy

%post
/sbin/ldconfig
/sbin/chkconfig --add %{name}
%service %{name} restart "MySQL Proxy"

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
/sbin/ldconfig
if [ "$1" = "0" ]; then
	%userremove mysqlproxy
	%groupremove mysqlproxy
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS NEWS README* ChangeLog
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%dir %attr(750,root,root) %{_sysconfdir}/%{name}
%config(noreplace) %attr(640,root,root) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/%{name}.conf
%attr(755,root,root) %{_sbindir}/%{name}

%attr(750,root,mysqlproxy) %dir /var/log/%{name}
%attr(750,root,mysqlproxy) %dir /var/log/archive/%{name}

# ??? tools?
%attr(755,root,root) %{_bindir}/mysql-binlog-dump
%attr(755,root,root) %{_bindir}/mysql-myisam-dump

%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/lua
%attr(755,root,root) %{_libdir}/%{name}/lua/chassis.so
%attr(755,root,root) %{_libdir}/%{name}/lua/glib2.so
%attr(755,root,root) %{_libdir}/%{name}/lua/lfs.so
%attr(755,root,root) %{_libdir}/%{name}/lua/lpeg.so
%attr(755,root,root) %{_libdir}/%{name}/lua/mysql.so
%attr(755,root,root) %{_libdir}/%{name}/lua/posix.so

%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/lua
%{_datadir}/%{name}/lua/admin.lua
%dir %{_datadir}/%{name}/lua/proxy
%{_datadir}/%{name}/lua/proxy/*.lua
%dir %{_datadir}/%{name}/lua/examples
%{_datadir}/%{name}/lua/examples/*.lua
%{_datadir}/%{name}/lua/examples/*.msc

%dir %{_libdir}/%{name}/plugins
%attr(755,root,root) %{_libdir}/%{name}/plugins/libadmin.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/libdebug.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/libproxy.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/libreplicant.so

# -libs
%attr(755,root,root) %ghost %{_libdir}/libmysql-chassis-timing.so.0
%attr(755,root,root) %{_libdir}/libmysql-chassis-timing.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmysql-chassis.so.0
%attr(755,root,root) %{_libdir}/libmysql-chassis.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmysql-chassis-glibext.so.0
%attr(755,root,root) %{_libdir}/libmysql-chassis-glibext.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmysql-proxy.so.0
%attr(755,root,root) %{_libdir}/libmysql-proxy.so.*.*.*
%changelog
* Sat Jan 11 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mysql-proxy.git;a=log;h=master

* Sat Jan 11 2014 Elan Ruusamäe <glen@delfi.ee> 5d71a04
- up to 0.8.4 (2014-01-10); The admin plugin now rejects empty passwords.

* Thu Nov 07 2013 Elan Ruusamäe <glen@delfi.ee> f56dec3
- fix for automake 1.12

* Thu Nov 07 2013 Elan Ruusamäe <glen@delfi.ee> d12ca80
- up to 0.8.3

* Thu Aug 18 2011 Elan Ruusamäe <glen@pld-linux.org> b57261f
- up to 0.8.2

* Fri Feb 25 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 40ef7e9
- rel 1

* Fri Sep 17 2010 Elan Ruusamäe <glen@pld-linux.org> 25aa875
- fix admin.lua install
- license version

* Fri Sep 17 2010 Elan Ruusamäe <glen@pld-linux.org> 66b97ac
- 0.8.1

* Wed Aug 04 2010 Elan Ruusamäe <glen@pld-linux.org> 1cd0fd3
- install example lua

* Wed Aug 04 2010 Elan Ruusamäe <glen@pld-linux.org> 9126a0b
- setup LUA_PATH

* Fri May 21 2010 Elan Ruusamäe <glen@pld-linux.org> a8bd7a2
- release 2

* Fri May 21 2010 Elan Ruusamäe <glen@pld-linux.org> 1ce41d3
- release 1

* Fri May 21 2010 Elan Ruusamäe <glen@pld-linux.org> 19034f1
- add custom admin-1.lua

* Tue May 18 2010 Elan Ruusamäe <glen@pld-linux.org> 2ea0dc3
- add contrib script: http://forge.mysql.com/tools/tool.php?id=252

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> bdc2536
- release 0.16

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> 2ff57b1
- comment config

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> dc83c96
- handle angel mode in initscript, but seems there is something very wrong and broken in the code with signals

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> 69fdabd
- flush-logs target

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> 6cf747e
- redirfds is back, problem with angel process

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> c5e5b3b
- redirfds is back

* Mon May 17 2010 Elan Ruusamäe <glen@pld-linux.org> 25a4068
- move .lua to /usr/share

